﻿using System;
using System.Collections.Generic;
using System.Linq;
using GenericLibrary;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace GenericLibraryTests
{
    [TestClass]
    public class CatalogListTests
    {
        private readonly Book _book1 = new Book(1, "Anders", "C#");
        private readonly Book _book2 = new Book(2, "John Sharp", "C# 2012");
        private CatalogList<int, Book> _books;

        [TestInitialize]
        public void Intialize()
        {
            _books = new CatalogList<int, Book> { _book1, _book2 };
        }

        [TestMethod]
        public void CopyConstructorTest()
        {
            IList<Book> b = new[] { new Book(4, "Hillar", "Parallel Programming with C#") };
            CatalogList<int, Book> boo = new CatalogList<int, Book>(b);
            Assert.AreEqual(1, boo.Count);
        }

        [TestMethod]
        public void AddCountTest()
        {
            Assert.AreEqual(2, _books.Count);
            Book anotherBook = new Book(3, "Bard de Smet", "C# 5.0 Unleashed");
            bool added = _books.Add(anotherBook);
            Assert.IsTrue(added);
            Assert.AreEqual(3, _books.Count);
            added = _books.Add(anotherBook);
            Assert.IsFalse(added);
        }

        [TestMethod]
        public void FindTest()
        {
            Book b = _books.Find(1);
            Assert.AreEqual(b, _book1);
            Assert.IsNull(_books.Find(100));
        }

        [TestMethod]
        public void GetAllTest()
        {
            ICollection<Book> allBooks = _books.GetAll();
            Assert.AreEqual(2, allBooks.Count());

            allBooks.Add(_book1);        
        }

      
    } 
}